import base64, strutils, os
include winim/[inc\winuser]
import miniz # zlib (un-)packer: https://nimble.directory/pkg/miniz

proc copyTextToClip*(sText = ""): bool {.discardable.} =
  if sText.len == 0:
    echo "Error! No text to copy!"
    return false
  let data = newWideCString(sText)
  let pData = cast[LPWSTR](data[0].addr)
  let iLen = data.len * 2 + 2
  let hMem = GlobalAlloc(GHND, cast[SIZE_T](iLen)) # GHND = Combines GMEM_MOVEABLE and GMEM_ZEROINIT
  if hMem == 0:
    echo "Error! Can't allocate memory!"
    return false
  let pMem = GlobalLock(hMem)
  if pMem == NULL:
    echo "Error! Can't lock memory!"
    return false
  copyMem(pMem, pData, iLen)
  GlobalUnlock(hMem)
  OpenClipboard(0)
  if SetClipboardData(CF_UNICODETEXT, hMem) == 0:
    GlobalFree(hMem)
    CloseClipboard()
    echo "Error! Can't copy to clipboard!"
    return false
  return CloseClipboard() != 0

proc BinToBase64*(fileName: string): bool {.discardable.} =
  if not existsFile(fileName):
    echo "Error! File doesn't exists!"
    return
  let data = readFile(fileName) # Daten einlesen
  if data.len == 0: return
  let compr = compress(data, level=9) # mit zlib (miniz) komprimieren (level=0..9)
  let mime = encodeMime(compr, 100) # Base64/Mime kodieren (100 Zeichen/Zeile, CRLF am Ende)
  copyTextToClip(mime) # in die Zwischenablage kopieren

proc Base64ToBin*(mime: string): TaintedString =
  if mime.len == 0: 
    echo "Error! Empty mime string!"
    return
  let repl = mime.multiReplace(("\r", ""), ("\n", "")) # CRLF am Ende entfernen
  if repl == "":
    echo "Error! Empty replace string!"
    return
  let decoded = decode(repl) # Base64/Mime dekodieren
  result = uncompress(decoded) # Daten dekomprimieren (miniz)

